<?php

/**
 * @author diverKon <diverKon@gmail.com>
 * @version 0.1
 * @copyright Copyright(C) KK.Kon
 * @license    http://opensource.org/licenses/bsd-license.php New BSD License
 * @since 2011-08-21
*/

/**
*/
class F8Payload
{
	const algorithm = 'algorithm';
	const issued_at = 'issued_at';

	// app_data is optional.
	//  tab app receive in payload
	//  canvas app receive in $_REQUEST
	const app_data = 'app_data';

	const user = 'user';

	const page = 'page';

	const credits = 'credits';

	// send if app installed
	const expires = 'expires';
	const oauth_token = 'oauth_token';
	const user_id = 'user_id';

	protected $facebook_request = null;

	public function __construct( $facebook_request )
	{
		$this->facebook_request = $facebook_request;
	}

	public function getUser()
	{
		if ( null != $this->facebook_request )
		{
			$user = F8client::getFacebookRequest1( $this->facebook_request, self::user );
			$f8payload_user = new F8PayloadUser( $user );
			return $f8payload_user;
		}
	
		return null;
	}

	public function getPage()
	{
		if ( null != $this->facebook_request )
		{
			$page = F8client::getFacebookRequest1( $this->facebook_request, self::page );
			$f8payload_page = new F8PayloadPage( $page );
			return $f8payload_page;
		}
	
		return null;
	}

	public function getCredits_GetItems()
	{
		if ( null != $this->facebook_request )
		{
			$credits = F8client::getFacebookRequest1( $this->facebook_request, self::credits );
			$f8payload_credits__get_items = new F8PayloadCredits_GetItems( $credits );
			return $f8payload_credits__get_items;
		}
	
		return null;
	}



	public function getAlgorithm()
	{
		if ( null != $facebook_request )
		{
			if ( isset($facebook_request[self::algorithm]) )
			{
				return $facebook_request[self::algorithm];
			}
		}

		return null;
	}
	public function getIssuedAt()
	{
		if ( null != $facebook_request )
		{
			if ( isset($facebook_request[self::issued_at]) )
			{
				return $facebook_request[self::issued_at];
			}
		}

		return null;
	}




	public function getExpires()
	{
		if ( null != $facebook_request )
		{
			if ( isset($facebook_request[self::expires]) )
			{
				return $facebook_request[self::expires];
			}
		}

		return null;
	}
	public function getOauthToken()
	{
		if ( null != $facebook_request )
		{
			if ( isset($facebook_request[self::oauth_token]) )
			{
				return $facebook_request[self::oauth_token];
			}
		}

		return null;
	}
	public function getUserId()
	{
		if ( null != $facebook_request )
		{
			if ( isset($facebook_request[self::user_id]) )
			{
				return $facebook_request[self::user_id];
			}
		}

		return null;
	}
	public function getAppData()
	{
		if ( null != $facebook_request )
		{
			if ( isset($facebook_request[self::app_data]) )
			{
				return $facebook_request[self::app_data];
			}
		}

		return null;
	}

}

class F8PayloadUser
{
	const country = 'country';
	const locale = 'locale';
	const age = 'age';

	protected $facebook_request_user = null;


	public function __construct( $facebook_request_user )
	{
		$this->facebook_request_user = $facebook_request_user;
	}

	public function getUserAge()
	{
		if ( null != $this->facebook_request_user )
		{
			$user_age = F8client::getFacebookRequest1( $this->facebook_request_user, self::age );
			$f8payload_user_age = new F8PayloadUserAge( $user_age );
			return $f8payload_user_age;
		}
	
		return null;
	}




	public function getCountry()
	{
		if ( null != $this->facebook_request_user )
		{
			if ( isset($this->facebook_request_user[self::country]) )
			{
				return $this->facebook_request_user[self::country];
			}
		}
		
		return null;
	}

	public function getLocale()
	{
		if ( null != $this->facebook_request_user )
		{
			if ( isset($this->facebook_request_user[self::locale]) )
			{
				return $this->facebook_request_user[self::locale];
			}
		}
		
		return null;
	}

}

class F8PayloadUserAge
{
	const min = 'min';

	protected $facebook_request_user_age = null;


	public function __construct( $facebook_request_user_age )
	{
		$this->facebook_request_user_age = $facebook_request_user_age;
	}

	public function getMin()
	{
		if ( null != $this->facebook_request_user_age )
		{
			if ( isset($this->facebook_request_user_age[self::min]) )
			{
				return $this->facebook_request_user_age[self::min];
			}
		}
		
		return null;
	}
}

class F8PayloadPage
{
	const id = 'id';
	const liked = 'liked';
	const admin = 'admin';

	protected $facebook_request_page = null;


	public function __construct( $facebook_request_page )
	{
		$this->facebook_request_page = $facebook_request_page;
	}




	public function getId()
	{
		if ( null != $this->facebook_request_page )
		{
			if ( isset($this->facebook_request_page[self::id]) )
			{
				return $this->facebook_request_page[self::id];
			}
		}
		
		return null;
	}

	public function getLiked()
	{
		if ( null != $this->facebook_request_page )
		{
			if ( isset($this->facebook_request_page[self::liked]) )
			{
				return $this->facebook_request_page[self::liked];
			}
		}
		
		return null;
	}

	public function getAdmin()
	{
		if ( null != $this->facebook_request_page )
		{
			if ( isset($this->facebook_request_page[self::admin]) )
			{
				return $this->facebook_request_page[self::admin];
			}
		}
		
		return null;
	}

}

class F8PayloadCredits_GetItems
{
	const buyer = 'buyer';
	const receiver = 'receiver';
	const order_id = 'order_id';
	const order_info = 'order_info';
	const test_mode = 'test_mode';


	const item_id = 'item_id';
	const title = 'title';
	const description = 'description';
	const price = 'price';
	const product_url = 'product_url';
	const image_url = 'image_url';
	const data = 'data';

	protected $facebook_request_credits = null;


	public function __construct( $facebook_request_credits )
	{
		$this->facebook_request_credits = $facebook_request_credits;
	}




	public function getBuyer()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::buyer]) )
			{
				return $this->facebook_request_credits[self::buyer];
			}
		}
		
		return null;
	}

	public function getReceiver()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::receiver]) )
			{
				return $this->facebook_request_credits[self::receiver];
			}
		}
		
		return null;
	}

	public function getOrderId()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::order_id]) )
			{
				return $this->facebook_request_credits[self::order_id];
			}
		}
		
		return null;
	}

	public function getOrderInfo()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::order_info]) )
			{
				return $this->facebook_request_credits[self::order_info];
			}
		}
		
		return null;
	}

	public function getTestMode()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::test_mode]) )
			{
				return $this->facebook_request_credits[self::test_mode];
			}
		}
		
		return null;
	}


}

class F8PayloadCredits_StatusUpdate
{
	const order_details = 'order_details';
	const status = 'status';
	const order_id = 'order_id';
	const test_mode = 'test_mode';


	const status__placed = 'placed';
	const status__disputed = 'disputed';

	const status__settled = 'settled';
	const status__canceled = 'canceled';
	const status__refunded = 'refunded';


	protected $facebook_request_credits = null;


	public function __construct( $facebook_request_credits )
	{
		$this->facebook_request_credits = $facebook_request_credits;
	}




	public function getOrderDetails()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::order_details]) )
			{
				return $this->facebook_request_credits[self::order_details];
			}
		}
		
		return null;
	}

	public function getStatus()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::status]) )
			{
				return $this->facebook_request_credits[self::status];
			}
		}
		
		return null;
	}

	public function getOrderId()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::order_id]) )
			{
				return $this->facebook_request_credits[self::order_id];
			}
		}
		
		return null;
	}

	public function getTestMode()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::test_mode]) )
			{
				return $this->facebook_request_credits[self::test_mode];
			}
		}
		
		return null;
	}


}

class F8Credits_StatusUpdate_OrderDetails
{
	const order_id = 'order_id';
	const buyer = 'buyer';
	const app = 'app';
	const receiver = 'receiver';
	const amount = 'amount';
	const update_time = 'update_time';
	const time_placed = 'time_placed';
	const data = 'data';
	const items = 'items';
	const status = 'status';


	const items__item_id = 'item_id';
	const items__title = 'title';
	const items__description = 'description';
	const items__image_url = 'image_url';
	const items__product_url = 'product_url';
	const items__price = 'price';
	const items__data = 'data';

	const status__settled = 'settled';
	const status__canceled = 'canceled';
	const status__refunded = 'refunded';



	const status__settled = 'settled';
	const status__canceled = 'canceled';
	const status__refunded = 'refunded';


	protected $facebook_request_credits = null;


	public function __construct( $facebook_request_credits )
	{
		$this->facebook_request_credits = $facebook_request_credits;
	}




	public function getOrderId()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::order_id]) )
			{
				return $this->facebook_request_credits[self::order_id];
			}
		}
		
		return null;
	}

	public function getBuyer()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::buyer]) )
			{
				return $this->facebook_request_credits[self::buyer];
			}
		}
		
		return null;
	}

	public function getApp()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::app]) )
			{
				return $this->facebook_request_credits[self::app];
			}
		}
		
		return null;
	}

	public function getReceiver()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::receiver]) )
			{
				return $this->facebook_request_credits[self::receiver];
			}
		}
		
		return null;
	}

	public function getAmount()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::amount]) )
			{
				return $this->facebook_request_credits[self::amount];
			}
		}
		
		return null;
	}

	public function getUpdateTime()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::update_time]) )
			{
				return $this->facebook_request_credits[self::update_time];
			}
		}
		
		return null;
	}

	public function getTimePlaced()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::time_placed]) )
			{
				return $this->facebook_request_credits[self::time_placed];
			}
		}
		
		return null;
	}

	public function getData()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::data]) )
			{
				return $this->facebook_request_credits[self::data];
			}
		}
		
		return null;
	}

	public function getItems()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::items]) )
			{
				return $this->facebook_request_credits[self::items];
			}
		}
		
		return null;
	}

	public function getStatus()
	{
		if ( null != $this->facebook_request_credits )
		{
			if ( isset($this->facebook_request_credits[self::status]) )
			{
				return $this->facebook_request_credits[self::status];
			}
		}
		
		return null;
	}


}



class F8client
{
	const signed_request = 'signed_request';

	const credits__method = 'method';
	const credits__method__payments_get_items = 'payments_get_items';
	const credits__method__payments_status_update = 'payments_status_update';

	protected $facebook_request = null;

	public function get_parsed_signed_request()
	{
		return $this->facebook_request;
	}


	/**
	 * base64 url decode 
	 * @see http://developers.facebook.com/docs/authentication/signed_request/
	 * @see RFC3548 Table 2
	 * 
	 * @param string $encoded_input
	 * @return string decoded string.
	 */
	public static function base64_url_decode( $encoded_input )
	{
		return base64_decode( strtr( $encoded_input, '-_', '+/' ) );
	}

	/**
	 * decode signed_request sended by facebook
	 * @see http://developers.facebook.com/docs/authentication/signed_request/
	 * 
	 * @param string $signed_request 
	 * @param string $secret application secret
	 * @return string decoded request. return null if failed.
	 */
	public function parse_signed_request( $signed_request, $app_secret )
	{
		if ( null == $signed_request )
		{
			error_log( 'signed_request is null.' );
			return null;
		}
		if ( null == $app_secret )
		{
			error_log( 'app_secret.' );
			return null;
		}

		if ( FALSE === strpos($signed_request,'.') )
		{
			error_log( 'not contain signed_request delimitor `.` signed_request=' + $signed_request );
			return null;
		}

		list( $encoded_sig, $payload ) = explode( '.', $signed_request, 2 );

		$sig = self::base64_url_decode( $encoded_sig );
		$decoded_payload = json_decode( self::base64_url_decode($payload), true );

		if ( empty($decoded_payload) )
		{
			return null;
		}

		$hash_algorithm = null;
		{
			$algorithm = strtoupper( $decoded_payload['algorithm'] );
			if ( 'HMAC-SHA256' === $algorithm )
			{
				$hash_algorithm = 'sha256';
			}

			if ( null == $hash_algorithm )
			{
				error_log( 'Unknown algorithm. algorithm=' + $algorithm );
				return null;
			}
		}

		$expected_sig = hash_hmac( $hash_algorithm, $payload, $app_secret, $raw = true );
		if ( $expected_sig !== $sig )
		{
			error_log( 'signature not match.' );
			return null;
		}

		$this->facebook_request = $decoded_payload;
		return $decoded_payload;
	}

	public function getF8Payload()
	{
		if ( null != $this->facebook_request )
		{
			$f8payload = new F8Payload($this->facebook_request);
			return $f8payload;
		}
	
		return null;
	}


	public function getRequest1( $field1 )
	{
		if ( null != $this->facebook_request )
		{
			if ( is_array($this->facebook_request) )
			{
				if ( isset($this->facebook_request[$field1]) )
				{
					return $this->facebook_request[$field1];
				}
			}
		}

		return null;
	}
	public function getRequest2( $field1, $field2 )
	{
		if ( null != $this->facebook_request )
		{
			if ( is_array($this->facebook_request) )
			{
				if ( isset($this->facebook_request[$field1]) )
				{
					if ( is_array($this->facebook_request[$field1]) )
					{
						if ( isset($this->facebook_request[$field1][$field2]) )
						{
							return $this->facebook_request[$field1][$field2];
						}
					}
				}
			}
		}
	
		return null;
	}

	public static function getFacebookRequest1( $facebook_request, $field1 )
	{
		if ( null != $facebook_request )
		{
			if ( is_array($facebook_request) )
			{
				if ( isset($facebook_request[$field1]) )
				{
					return $facebook_request[$field1];
				}
			}
		}

		return null;
	}
	public static function getFacebookRequest2( $facebook_request, $field1, $field2 )
	{
		if ( null != $facebook_request )
		{
			if ( is_array($facebook_request) )
			{
				if ( isset($facebook_request[$field1]) )
				{
					if ( is_array($facebook_request[$field1]) )
					{
						if ( isset($facebook_request[$field1][$field2]) )
						{
							return $facebook_request[$field1][$field2];
						}
					}
				}
			}
		}
	
		return null;
	}

}


