<?php

/**
 * @author diverKon <diverKon@gmail.com>
 * @version 0.1
 * @copyright Copyright(C) KK.Kon
 * @license    http://opensource.org/licenses/bsd-license.php New BSD License
 * @since 2011-08-21
*/

if (!defined('__DIR__'))
{
    define('__DIR__',dirname(__FILE__));
}

$dirname = __DIR__;
$appdirname = null;
{
    $dirname = str_replace( '\\', '/', $dirname );
    $folders = explode( '/', $dirname );
    $folders_count = count($folders);
    if ( 1 <= $folders_count )
    {
        $appdirname = $folders[$folders_count-1];
    }
}

require_once __DIR__ . '/f8conf.inc.php';
require_once __DIR__ . '/F8client.class.php';

$signed_request = null;
$f8 = new F8client();
if ( !isset( $_REQUEST[F8client::signed_request] ) )
{
    error_log( $_SERVER['PHP_SELF'] . 'signed_request not found.' );
}
else
{
    $signed_request = $_REQUEST[F8client::signed_request];
}
$fb_request = $f8->parse_signed_request( $signed_request, MY_APP_SECRET );
if ( defined('DEBUG') )
{
    error_log( $_SERVER['PHP_SELF'] . '$_REQUEST=' . var_export( $_REQUEST, TRUE ) );
    error_log( $_SERVER['PHP_SELF'] . '$fb_request=' . var_export( $fb_request, TRUE ) );
}


$method_request = null;
if ( !isset($_REQUEST[F8client::credits__method]) )
{
    error_log( $_SERVER['PHP_SELF'] . 'signed_request not found.' );
    if ( ! defined('DEBUG') )
    {
        return;
    }
}
else
{
    $method_request = $_REQUEST[F8client::credits__method];
}

error_log( '$method_request: ' . $method_request );
if ( 0 == strcmp(F8client::credits__method__payments_get_items,$method_request) )
{
    error_log( 'payments_get_items: start' );
    $f8payload = $f8->getF8Payload();
    $credits_getitems = $f8payload->getCredits_GetItems();

    $test_mode = '';
    if ( null != $credits_getitems->getTestMode() )
    {
        $test_mode = '[Test Mode] ';
    }

    $req_order_info = $credits_getitems->getOrderInfo();
    if ( null != $req_order_info )
    {
        $req_order_info = stripcslashes( $req_order_info );
    }
    $price = 1;
    error_log( 'req_order_info: ' . $req_order_info );
    if ( null != $req_order_info )
    {
        if ( 0 == strcmp( $req_order_info, '"oi1"' ) )
        {
            $price = 1;
        }
        else
        if ( 0 == strcmp( $req_order_info, '"oi2"' ) )
        {
            $price = 10;
        }
        else
        if ( 0 == strcmp( $req_order_info, '"oi3"' ) )
        {
            $price = 50;
        }
        else
        {
        }
    }
    error_log( 'price: ' . $price );

    $array_items = array();

    // TODO fetch from DB
    // but Facebook Platform allows one item
    // multiple item sepalete order_info
    for ( $i = 1; $i <= 1; $i += 1 )
    {
        $item = array();
        $item[F8PayloadCredits_GetItems::item_id] = $i;
        $item[F8PayloadCredits_GetItems::title] = $test_mode . 'title ' . $price; // 50 character
        $item[F8PayloadCredits_GetItems::description] = $test_mode . 'description ' . $price; // 175 character
        $item[F8PayloadCredits_GetItems::price] = $price; // greater than 0 credits
        $item[F8PayloadCredits_GetItems::product_url] = 'http://www.facebook.com/images/gifts/21.png';
        $item[F8PayloadCredits_GetItems::image_url] = 'http://www.facebook.com/images/gifts/21.png';
        $item[F8PayloadCredits_GetItems::data] = null;

        $array_items[] = $item;
    }

    $response = array();
    $response['content'] = $array_items;
    $response[F8client::credits__method] = $method_request;
    $json_response = json_encode( $response );
    {
        $json_last_error = json_last_error();
        if ( JSON_ERROR_NONE != $json_last_error )
        {
            error_log( 'json_encode fail. err=' . $json_last_error );
        }
    }

    {
        error_log( 'json_response: ' . $json_response );
        header( 'Content-Type: application/json; charset=utf-8' );
        echo $json_response;
    }
    error_log( 'payments_get_items: finish' );
}
else
if ( 0 == strcmp(F8client::credits__method__payments_status_update,$method_request) )
{
    error_log( 'payments_status_update: start' );
    $f8payload = $f8->getF8Payload();
    $credits_statusupdate = $f8payload->getCredits_StatusUpdate();

    $response_status = null;
    //$response_status = F8PayloadCredits_StatusUpdate::status__settled;
    //$response_status = F8PayloadCredits_StatusUpdate::status__canceled;
    //$response_status = F8PayloadCredits_StatusUpdate::status__refunded;

    $credits_status = $credits_statusupdate->getStatus();
    $credits_order_id = $credits_statusupdate->getOrderId();

    error_log( 'credits_status: ' . $credits_status . ' credits_order_id=' . $credits_order_id . ' ' . __FILE__ . ' on ' . __LINE__  );
    if ( null != $credits_status )
    {
        if ( 0 == strcmp( F8PayloadCredits_StatusUpdate::status__placed, $credits_status ) )
        {
            $response_status = F8PayloadCredits_StatusUpdate::status__settled;
        }
        else
        if ( 0 == strcmp( F8PayloadCredits_StatusUpdate::status__settled, $credits_status ) )
        {
            $response_status = F8PayloadCredits_StatusUpdate::status__settled;
        }
        else
        if ( 0 == strcmp( F8PayloadCredits_StatusUpdate::status__disputed, $credits_status ) )
        {
            // TODO disputed by user?
            // may be notification to app owner and cancel order_id(refund etc.)
        }
        else
        {
            error_log( 'credits_order_id: ' . $credits_order_id . ',status: ' . $credits_status );
        }
    }

    $response = array();
    $array_items = array();
    if ( !empty($response_status) )
    {
        $array_items[F8PayloadCredits_StatusUpdate::status] = $response_status;
    }
    $array_items[F8PayloadCredits_StatusUpdate::order_id] = $credits_order_id;
    $response['content'] = $array_items;
    $response[F8client::credits__method] = $method_request;
    $json_response = json_encode( $response );
    {
        $json_last_error = json_last_error();
        if ( JSON_ERROR_NONE != $json_last_error )
        {
            error_log( 'json_encode fail. err=' . $json_last_error );
        }
    }

    {
        error_log( 'json_response: ' . $json_response );
        header( 'Content-Type: application/json; charset=utf-8' );
        echo $json_response;
    }
    error_log( 'payments_status_update: finish' );
}
else
{
    error_log( 'unknown method. method=' . $method_request );
}

?>
