<?php

/**
 * @author diverKon <diverKon@gmail.com>
 * @version 0.1
 * @copyright Copyright(C) KK.Kon
 * @license    http://opensource.org/licenses/bsd-license.php New BSD License
 * @since 2011-08-21
*/

if (!defined('__DIR__'))
{
    define('__DIR__',dirname(__FILE__));
}

$dirname = __DIR__;
$appdirname = null;
{
    $dirname = str_replace( '\\', '/', $dirname );
    $folders = explode( '/', $dirname );
    $folders_count = count($folders);
    if ( 1 <= $folders_count )
    {
        $appdirname = $folders[$folders_count-1];
    }
}

require_once __DIR__ . '/f8conf.inc.php';
require_once __DIR__ . '/F8client.class.php';

$signed_request = null;
$f8 = new F8client();
if ( !isset( $_REQUEST[F8client::signed_request] ) )
{
    error_log( $_SERVER['PHP_SELF'] . 'signed_request not found.' );
    if ( ! defined('DEBUG') )
    {
        return;
    }
}
else
{
    $signed_request = $_REQUEST[F8client::signed_request];
}
$fb_request = $f8->parse_signed_request( $signed_request, MY_APP_SECRET );
if ( defined('DEBUG') )
{
    error_log( $_SERVER['PHP_SELF'] . var_export( $fb_request, TRUE ) );
}

?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml"
 xmlns:fb="http://www.facebook.com/2008/fbml">
<head>
</head>
<body>

<?php
  if ( defined('DEBUG') )
  {
    echo '<!--' . PHP_EOL;
    echo var_export($_REQUEST, true ) . PHP_EOL;
    echo '-->' . PHP_EOL;
    echo '<!--' . PHP_EOL;
    echo var_export($fb_request, true ) . PHP_EOL;
    echo '-->' . PHP_EOL;
  }
?>

  <div id="fb-root"></div>
  <script src="http://connect.facebook.net/en_US/all.js"></script>

  <!-- TODO query from DB -->
  <p><a href="#" onclick="placeOrder('oi1'); return false;">Buy</a></p>

  <p><a href="#" onclick="placeOrder('oi2'); return false;">Buy</a></p>

  <p><a href="#" onclick="placeOrder('oi3'); return false;">Buy</a></p>

  <script>
    console.log( 'FB.init before' );
    FB.init({
      appId: '<?php echo MY_APP_ID; ?>'
    , cookie: true
    , status: true
    , xfbml: true
    , oauth: true
    });
    console.log( 'FB.init after' );
    FB.getLoginStatus(
      function(response) {
        var isInstalled = false;
        console.log( response );
        if (response)
        {
          if ( response.authResponse )
          {
            isInstalled = true;
          }
          else
          {
          }
        }

        if (!isInstalled)
        {
          //request_permission();
        }
      }
    );

    function request_permission()
    {
      var oauth_url = 'http://www.facebook.com/dialog/oauth/?'
        + 'client_id=<?php echo MY_APP_ID; ?>'
        + '&redirect_uri=' + '<?php echo MY_APP_CANVAS_URL; ?>oauth_result.php'
        //+ '&scope=email'
        //+ '&state=種'
        + '&response_type=token';
        //+ '&display=token';
      //alert( 'oauth_url: ' + oauth_url );
      top.location.href = oauth_url;
    }

    function placeOrder(param_order_info) {
      console.log( 'FB.ui(pay) before' );
      if ( undefined == param_order_info )
      {
          return false;
      }

      var param_obj = {
        method: 'pay' // not modify
      , order_info: param_order_info
      , purchase_type: 'item' // not modify
      , dev_purchase_params: {"dev_param":"dev_value"}
      };

      FB.ui( param_obj, orderCallback );
      console.log( 'FB.ui(pay) after' );
    }

    var orderCallback = function( response ) {
      console.log( 'orderCallback start' );
      console.log( response );
      console.log( 'orderCallback end' );
    };
  </script>
</body>
</html>
